local T, C, L, _ = unpack(select(2, ...))

----------------------------------------------------------------------------------------
--	Move QuestWatchFrame (with ModernQuestWatch from Ketho - EU-Boulderfist)
----------------------------------------------------------------------------------------
local function updateMinimizeButton(self)
	WatchFrameCollapseExpandButton.__texture:DoCollapse(self.collapsed)
end

local function reskinMinimizeButton(button)
	T.ReskinCollapse(button)
	button:GetNormalTexture():SetAlpha(0)
	button:GetPushedTexture():SetAlpha(0)
	button.__texture:DoCollapse(false)
end

local function reskinQuestIcon(button)
	if not button then return end
	if not button.SetNormalTexture then return end

	if not button.styled then
		button:SetSize(20, 20)
		button:SetNormalTexture("")
		button:SetPushedTexture("")
		button:GetHighlightTexture():SetColorTexture(1, 1, 1, 0.3)
		local icon = _G[button:GetName().."IconTexture"]
		if icon then
			icon:SkinIcon()
		end

		button.styled = true
	end

	if button.backdrop then
		button.backdrop:SetFrameLevel(0)
	end
end

local function QuestTracker()
	WatchFrame:ClearAllPoints()
	WatchFrame:SetPoint(unpack(C.position.quest))
	WatchFrame:SetWidth(210)
	WatchFrame:SetHeight(GetScreenHeight()*.65)

	hooksecurefunc(WatchFrame, "SetPoint", function(self, _, parent)
		if parent ~= UIParent then
			self:ClearAllPoints()
			self:SetPoint(unpack(C.position.quest))
		end
	end)

	hooksecurefunc("WatchFrameItem_UpdateCooldown", function(button)
		reskinQuestIcon(button)
	end)

	reskinMinimizeButton(WatchFrameCollapseExpandButton)
	hooksecurefunc("WatchFrame_Collapse", updateMinimizeButton)
	hooksecurefunc("WatchFrame_Expand", updateMinimizeButton)

	-- Extend the wrap text on WatchFrame, needs review
	hooksecurefunc("WatchFrame_SetLine", function(line)
		line:SetHeight(14)
		line.text:SetHeight(12)
		line.text:SetFont(C.media.normal_font, 12)
	end)

	-- Allow to send quest name
	hooksecurefunc("WatchFrameLinkButtonTemplate_OnClick", function(self)
		if IsModifiedClick("CHATLINK") and ChatEdit_GetActiveWindow() then
			if self.type == "QUEST" then
				local name, level = GetQuestLogTitle(GetQuestIndexForWatch(self.index))
				if name then
					ChatEdit_InsertLink("["..name.."]")
				end
			end
		end
	end)

	if C.general.minimize_mouseover then
		WatchFrameCollapseExpandButton:SetAlpha(0)
		WatchFrameCollapseExpandButton:HookScript("OnEnter", function() WatchFrameCollapseExpandButton:SetAlpha(1) end)
		WatchFrameCollapseExpandButton:HookScript("OnLeave", function() WatchFrameCollapseExpandButton:SetAlpha(0) end)
	end
	
	WatchFrameHeader:SetAlpha(0)

	WatchFrameCollapseExpandButton:ClearAllPoints()
	WatchFrameCollapseExpandButton:SetPoint("TOPLEFT", UIParent, "TOPLEFT", 5, -10)
	WatchFrameCollapseExpandButton:SetFrameLevel(WatchFrame:GetFrameLevel() + 1)
end

local f = CreateFrame("Frame")
f:RegisterEvent("PLAYER_ENTERING_WORLD")
f:SetScript("OnEvent", QuestTracker)
----------------------------------------------------------------------------------------
--	Auto collapse QuestWatchFrame
----------------------------------------------------------------------------------------
if C.automation.auto_collapse ~= "NONE" then
	local function WatchFrameCollapseExpand()
		WatchFrameCollapseExpandButton:Click()
	end

	local collapse = CreateFrame("Frame")
	collapse:RegisterEvent("PLAYER_ENTERING_WORLD")
	collapse:RegisterEvent("ZONE_CHANGED")
	collapse:RegisterEvent("ZONE_CHANGED_INDOORS")
	collapse:RegisterEvent("ZONE_CHANGED_NEW_AREA")
	collapse:SetScript("OnEvent", function(self)
		if C.automation.auto_collapse == "RAID" then
			if IsInInstance() then
				self:UnregisterAllEvents()
				C_Timer.After(1, WatchFrameCollapseExpand)
			end
		elseif C.automation.auto_collapse == "RELOAD" then
			self:UnregisterAllEvents()
			C_Timer.After(1, WatchFrameCollapseExpand)
		end
	end)
end