﻿local knowFish = false
local spell = GetSpellInfo(7620)
local isPole = false
local holder = CreateFrame("Frame", nil, UIParent);
-- Lure library
local fishlure = {
    {    ["id"] = 34832, --拉姆瑟船长的特酿啤酒  10 for 3 mins
        ["n"] = "Captain Rumsey's Lager",
        ["b"] = 10,
        ["s"] = 1,
        ["d"] = 3,
        ["u"] = 1,
     },
    {    ["id"] = 6529, -- 闪光的小珠 25 for 10 mins
        ["n"] = "Shiny Bauble",
        ["b"] = 25,
        ["s"] = 1,
        ["d"] = 10,
    },
    {    ["id"] = 6811, -- 水下鱼珠 50 for 10 mins
        ["n"] = "Aquadynamic Fish Lens",
        ["b"] = 50,
        ["s"] = 50,
        ["d"] = 10,
    },
    {    ["id"] = 6530, -- 夜色虫 50 for 10 mins
        ["n"] = "Nightcrawlers",
        ["b"] = 50,
        ["s"] = 50,
        ["d"] = 10,
    },
    {    ["id"] = 88710, -- 纳特的帽子 150 for 10 minutes
        ["n"] = "Nat's Hat",
        ["b"] = 150,
        ["s"] = 1,
        ["d"] = 10,
        ["w"] = true,
    },
    {    ["id"] = 33820, -- 饱经风霜的渔帽 75 for 10 minutes
        ["n"] = "Weather-Beaten Fishing Hat",
        ["b"] = 75,
        ["s"] = 1,
        ["d"] = 10,
        ["w"] = true,
    },
    {    ["id"] = 7307, -- 食腐虫 75 for 10 mins
        ["n"] = "Flesh Eating Worm",
        ["b"] = 75,
        ["s"] = 100,
        ["d"] = 10,
    },
    {    ["id"] = 6532, -- 明亮的小珠 75 for 10 mins
        ["n"] = "Bright Baubles",
        ["b"] = 75,
        ["s"] = 100,
        ["d"] = 10,
    },
    {    ["id"] = 34861, -- 锐利的鱼钩 100 for 10 minutes
        ["n"] = "Sharpened Fish Hook",
        ["b"] = 100,
        ["s"] = 100,
        ["d"] = 10,
    },
    {    ["id"] = 6533, --水下诱鱼器 100 for 10 minutes
        ["n"] = "Aquadynamic Fish Attractor",
        ["b"] = 100,
        ["s"] = 100,
        ["d"] = 10,
    },
    {    ["id"] = 62673, --羽状诱饵 100 for 10 minutes
        ["n"] = "Feathered Lure",
        ["b"] = 100,
        ["s"] = 100,
        ["d"] = 10,
    },
    {    ["id"] = 46006, -- 发光的虫子 100 for 60 minutes
        ["n"] = "Glow Worm",
        ["b"] = 100,
        ["s"] = 100,
        ["d"] = 60,
    },
    {    ["id"] = 68049, --耐热疾旋型诱饵 150 for 5 minutes
        ["n"] = "Heat-Treated Spinning Lure",
        ["b"] = 150,
        ["s"] = 250,
        ["d"] = 5,
    },
    {    ["id"] = 67404, --玻璃浮漂 附在你的鱼竿上可使你的钓鱼技能提高15点，持续10分钟
        ["n"] = "Glass Fishing Bobber",
        ["b"] = 15,
        ["s"] = 1,
        ["d"] = 10,
    },
}
table.sort(fishlure,
    function(a,b)
        if ( a.b == b.b ) then
            return a.d < b.d;
        else
            return a.b < b.b;
        end
    end
)
local function ResetOverride()
    btn.holder:Hide();
    ClearOverrideBindings(btn);
end
local function GetCurrentSkill()
    local rank = 0
    for skillIndex = 1, GetNumSkillLines() do
        local skillName, isHeader, _, skillRank = GetSkillLineInfo(skillIndex)
        if not isHeader then
            if skillName == "钓鱼" then
                rank = skillRank
                break
            end
        end
    end
    return rank
end
local useinventory = {};
local lureinventory = {};
local function UpdateLureInventory()
    local rawskill = GetCurrentSkill();
    useinventory = {};
    lureinventory = {};
    for _,lure in ipairs(fishlure) do
        local id = lure.id;
        local count = GetItemCount(id);
        if ( count > 0 ) then
            if ( lure.w ) then
                tinsert(lureinventory, lure);
            elseif ( lure.s <= rawskill ) then
                if ( not lure.w) then
                    tinsert(useinventory, lure);
                end
            end
            lure.n = GetItemInfo(id);
        end
    end
end

local function ClickHandled(self)
    ResetOverride();
end
local function OverrideClick()
    SetOverrideBindingClick(btn, true, "BUTTON2", "FishHolder"); --双击右键出杆
    btn.holder:Show();
end
btn = CreateFrame("Button", "FishHolder", holder, "SecureActionButtonTemplate");
btn.holder = holder;
btn:EnableMouse(true);
btn:RegisterForClicks("RightButtonUp"); --双击右键出杆
btn:Show();

holder:SetPoint("LEFT", UIParent, "RIGHT", 10000, 0);
holder:SetFrameStrata("LOW");
holder:Hide();
btn:SetScript("PostClick", ClickHandled)

local function IsFishPole()
    local item_id = GetInventoryItemID("player", 16)
    if item_id then
        local _, _, _, _, _, item_type, item_subtype = GetItemInfoInstant(item_id)
        if item_type == 2 and item_subtype == 20 then
            return true
        end
    end
        return false
end
local lastClickTime = nil
local function CheckForDoubleClick()
    if lastClickTime then
        local pressTime = GetTime()
        local doubleTime = pressTime - lastClickTime
        if ( (doubleTime < 0.4) and (doubleTime > 0.05) ) then
            lastClickTime = nil
            return true
        end
    end
    lastClickTime = GetTime()
    return false
end
local function OnMouseDown(...)
    local button = select(2, ...)
    if button == "RightButton" and not InCombatLockdown() and CheckForDoubleClick() and knowFish and isPole then --双击右键出杆
        UpdateLureInventory()
        local hasMainHandEnchant=GetWeaponEnchantInfo()
        if hasMainHandEnchant then
            btn:SetAttribute("type", "spell")
            btn:SetAttribute('spell', spell)
        elseif #lureinventory > 0 then
            btn:SetAttribute("type", "item")
            btn:SetAttribute("item", "item:"..lureinventory[1].id)
            if GetItemCooldown(lureinventory[1].id) > 0 then
                btn:SetAttribute("type", "spell")
                btn:SetAttribute('spell', spell)
            end
        elseif #useinventory > 0 then
            btn:SetAttribute("type", "item")
            btn:SetAttribute("item", "item:"..useinventory[1].id)
            if GetItemCooldown(useinventory[1].id) > 0 then
                btn:SetAttribute("type", "spell")
                btn:SetAttribute('spell', spell)
            end
        else
            btn:SetAttribute("type", "spell")
            btn:SetAttribute('spell', spell)
        end
            OverrideClick()
    end
end
btn:RegisterEvent("PLAYER_ENTERING_WORLD")
btn:RegisterEvent("PLAYER_EQUIPMENT_CHANGED")
btn:SetScript("OnEvent", function(self, event)
    if event == "PLAYER_ENTERING_WORLD" then
        self:UnregisterEvent("PLAYER_ENTERING_WORLD")
        if (IsSpellKnown(51294)) or (IsSpellKnown(33095)) or (IsSpellKnown(18248)) or (IsSpellKnown(7732)) or (IsSpellKnown(7731)) or (IsSpellKnown(7620)) then
            knowFish = true
            WorldFrame:HookScript("OnMouseDown", OnMouseDown)
        end
        isPole = IsFishPole()
        UpdateLureInventory()
    end
    if event == "PLAYER_EQUIPMENT_CHANGED" then
        isPole = IsFishPole()
    end
    if not InCombatLockdown() and knowFish and isPole then
        UpdateLureInventory()
    end
end)